using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

///////////////////////////////////////////////////////////////////////////////////
// VXPLib example
//
// Advanced Menus for C#
//
// Last Modified on 11/06/2003
//
// This example is intellectual property of Tooltips.NET L.L.C.
//
// For details visit www.Tooltips.NET
///////////////////////////////////////////////////////////////////////////////////
namespace AdvancedMenus
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;

		// One instance of VXPQuickHTML for each ownerdrawn menu item:
		private VXPLibrary.VXPQuickHTML fNew = new VXPLibrary.VXPQuickHTMLClass();
		private VXPLibrary.VXPQuickHTML fOpen = new VXPLibrary.VXPQuickHTMLClass();
		private VXPLibrary.VXPQuickHTML fSave = new VXPLibrary.VXPQuickHTMLClass();
		private VXPLibrary.VXPQuickHTML fPreview = new VXPLibrary.VXPQuickHTMLClass();
		private VXPLibrary.VXPQuickHTML fPrint = new VXPLibrary.VXPQuickHTMLClass();
		private VXPLibrary.VXPQuickHTML fExit = new VXPLibrary.VXPQuickHTMLClass();
		private VXPLibrary.VXPQuickHTML fAbout = new VXPLibrary.VXPQuickHTMLClass();
		private VXPLibrary.VXPQuickHTML fFile = new VXPLibrary.VXPQuickHTMLClass();
		private VXPLibrary.VXPQuickHTML fHelp = new VXPLibrary.VXPQuickHTMLClass();
		private VXPLibrary.VXPQuickHTML fSeparator = new VXPLibrary.VXPQuickHTMLClass();
		private VXPLibrary.VXPQuickHTML fCaption = new VXPLibrary.VXPQuickHTMLClass();
		private VXPLibrary.VXPQuickHTML fFooter = new VXPLibrary.VXPQuickHTMLClass();
		private VXPLibrary.VXPQuickHTML fMenuBar = new VXPLibrary.VXPQuickHTMLClass();

		// Instance of Tooltip Manager:
		private VXPLibrary.VXPTooltipManager tt = new VXPLibrary.VXPTooltipManagerClass();

		private System.Windows.Forms.MenuItem FileNew;
		private System.Windows.Forms.MenuItem FileOpen;
		private System.Windows.Forms.MenuItem FileSave;
		private System.Windows.Forms.MenuItem FilePreview;
		private System.Windows.Forms.MenuItem FilePrint;
		private System.Windows.Forms.MenuItem FileExit;
		private System.Windows.Forms.MenuItem HelpAbout;
		private System.Windows.Forms.MenuItem FileMenu;
		private System.Windows.Forms.MenuItem HelpMenu;
		private System.Windows.Forms.MenuItem Separator1;
		private System.Windows.Forms.MenuItem Separator2;
		private System.Windows.Forms.MenuItem FileCaption;
		private System.Windows.Forms.MenuItem FileFooter;
		private System.Windows.Forms.CheckBox DisableOpen;
		private System.Windows.Forms.CheckBox HideSave;
		private System.Windows.Forms.CheckBox CustomBackground;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		//**************************************************************//
		// Custom menu background color support:
		//**************************************************************//

		// A few constants required for overriding menu background color;
		const int WM_INITMENUPOPUP = 279;
		const int MIM_BACKGROUND = 2;
		const int COLOR_MENU = 4;

		// This procedure is just to simplify the use
		// of the standard RGB color presentation:
		public static uint RGB(byte Red, byte Green, byte Blue)
		{
			return (uint)(Red | Green << 8 | Blue << 16);
		}

		// Three exported functions necessary for overriding
		// menu background color:
		[DllImport("Gdi32.dll")]
		public static extern int CreateSolidBrush(uint crColor);

		[DllImport("User32.dll")]
		public unsafe static extern int SetMenuInfo(System.IntPtr wParam, MENUINFO * lpcmi);

		[DllImport("User32.dll")]
		public static extern int GetSysColorBrush(int nIndex);
		
		// Handle of our custom menu background brush
		// We make it static, and of vivid yellow color:
		static int MenuBrush = CreateSolidBrush(RGB(255, 255, 220));

		public struct MENUINFO
		{
			public int cbSize;
			public int fMask;
			public int dwStyle;
			public uint cyMax;
			public int hbrBack;
			public int dwContextHelpID;
			public int dwMenuData;
		};

		// Overriding the Form WndProc just to change menu
		// background color:
		protected unsafe override void WndProc(ref Message m)
		{
			if(m.Msg == WM_INITMENUPOPUP)
			{
				MENUINFO info;
				info.cbSize = sizeof(MENUINFO);
				info.fMask = MIM_BACKGROUND;
				if(CustomBackground.Checked) // If need to override menu background color
					info.hbrBack = MenuBrush;
				else
					info.hbrBack = GetSysColorBrush(COLOR_MENU); // Just use menu system color

				SetMenuInfo(m.WParam, &info); // Changing the color
			}
			base.WndProc(ref m);
		}

		//**************************************************************//
		// End of custom menu background color implementation
		//**************************************************************//

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.FileMenu = new System.Windows.Forms.MenuItem();
			this.FileCaption = new System.Windows.Forms.MenuItem();
			this.FileNew = new System.Windows.Forms.MenuItem();
			this.FileOpen = new System.Windows.Forms.MenuItem();
			this.FileSave = new System.Windows.Forms.MenuItem();
			this.Separator1 = new System.Windows.Forms.MenuItem();
			this.FilePreview = new System.Windows.Forms.MenuItem();
			this.FilePrint = new System.Windows.Forms.MenuItem();
			this.Separator2 = new System.Windows.Forms.MenuItem();
			this.FileExit = new System.Windows.Forms.MenuItem();
			this.FileFooter = new System.Windows.Forms.MenuItem();
			this.HelpMenu = new System.Windows.Forms.MenuItem();
			this.HelpAbout = new System.Windows.Forms.MenuItem();
			this.DisableOpen = new System.Windows.Forms.CheckBox();
			this.HideSave = new System.Windows.Forms.CheckBox();
			this.CustomBackground = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.FileMenu,
																					  this.HelpMenu});
			// 
			// FileMenu
			// 
			this.FileMenu.Index = 0;
			this.FileMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.FileCaption,
																					 this.FileNew,
																					 this.FileOpen,
																					 this.FileSave,
																					 this.Separator1,
																					 this.FilePreview,
																					 this.FilePrint,
																					 this.Separator2,
																					 this.FileExit,
																					 this.FileFooter});
			this.FileMenu.OwnerDraw = true;
			this.FileMenu.Text = "&File";
			this.FileMenu.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.FileMenu_DrawItem);
			this.FileMenu.MeasureItem += new System.Windows.Forms.MeasureItemEventHandler(this.FileMenu_MeasureItem);
			// 
			// FileCaption
			// 
			this.FileCaption.Index = 0;
			this.FileCaption.OwnerDraw = true;
			this.FileCaption.Text = "-";
			this.FileCaption.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.FileCaption_DrawItem);
			this.FileCaption.MeasureItem += new System.Windows.Forms.MeasureItemEventHandler(this.FileCaption_MeasureItem);
			// 
			// FileNew
			// 
			this.FileNew.Index = 1;
			this.FileNew.OwnerDraw = true;
			this.FileNew.Text = "&New";
			this.FileNew.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.FileNew_DrawItem);
			this.FileNew.MeasureItem += new System.Windows.Forms.MeasureItemEventHandler(this.FileNew_MeasureItem);
			// 
			// FileOpen
			// 
			this.FileOpen.Index = 2;
			this.FileOpen.OwnerDraw = true;
			this.FileOpen.Text = "&Open";
			this.FileOpen.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.FileOpen_DrawItem);
			this.FileOpen.MeasureItem += new System.Windows.Forms.MeasureItemEventHandler(this.FileOpen_MeasureItem);
			// 
			// FileSave
			// 
			this.FileSave.Index = 3;
			this.FileSave.OwnerDraw = true;
			this.FileSave.Text = "&Save";
			this.FileSave.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.FileSave_DrawItem);
			this.FileSave.MeasureItem += new System.Windows.Forms.MeasureItemEventHandler(this.FileSave_MeasureItem);
			// 
			// Separator1
			// 
			this.Separator1.Index = 4;
			this.Separator1.OwnerDraw = true;
			this.Separator1.Text = "-";
			this.Separator1.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.Separator1_DrawItem);
			this.Separator1.MeasureItem += new System.Windows.Forms.MeasureItemEventHandler(this.Separator1_MeasureItem);
			// 
			// FilePreview
			// 
			this.FilePreview.Index = 5;
			this.FilePreview.OwnerDraw = true;
			this.FilePreview.Text = "Print Pre&view";
			this.FilePreview.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.FilePreview_DrawItem);
			this.FilePreview.MeasureItem += new System.Windows.Forms.MeasureItemEventHandler(this.FilePreview_MeasureItem);
			// 
			// FilePrint
			// 
			this.FilePrint.Index = 6;
			this.FilePrint.OwnerDraw = true;
			this.FilePrint.Text = "&Print";
			this.FilePrint.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.FilePrint_DrawItem);
			this.FilePrint.MeasureItem += new System.Windows.Forms.MeasureItemEventHandler(this.FilePrint_MeasureItem);
			// 
			// Separator2
			// 
			this.Separator2.Index = 7;
			this.Separator2.OwnerDraw = true;
			this.Separator2.Text = "-";
			this.Separator2.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.Separator2_DrawItem);
			this.Separator2.MeasureItem += new System.Windows.Forms.MeasureItemEventHandler(this.Separator2_MeasureItem);
			// 
			// FileExit
			// 
			this.FileExit.Index = 8;
			this.FileExit.OwnerDraw = true;
			this.FileExit.Text = "E&xit";
			this.FileExit.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.FileExit_DrawItem);
			this.FileExit.Click += new System.EventHandler(this.FileExit_Click);
			this.FileExit.MeasureItem += new System.Windows.Forms.MeasureItemEventHandler(this.FileExit_MeasureItem);
			// 
			// FileFooter
			// 
			this.FileFooter.Index = 9;
			this.FileFooter.OwnerDraw = true;
			this.FileFooter.Text = "-";
			this.FileFooter.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.FileFooter_DrawItem);
			this.FileFooter.MeasureItem += new System.Windows.Forms.MeasureItemEventHandler(this.FileFooter_MeasureItem);
			// 
			// HelpMenu
			// 
			this.HelpMenu.Index = 1;
			this.HelpMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.HelpAbout});
			this.HelpMenu.OwnerDraw = true;
			this.HelpMenu.Text = "&Help";
			this.HelpMenu.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.HelpMenu_DrawItem);
			this.HelpMenu.MeasureItem += new System.Windows.Forms.MeasureItemEventHandler(this.HelpMenu_MeasureItem);
			// 
			// HelpAbout
			// 
			this.HelpAbout.Index = 0;
			this.HelpAbout.OwnerDraw = true;
			this.HelpAbout.Text = "&About";
			this.HelpAbout.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.HelpAbout_DrawItem);
			this.HelpAbout.MeasureItem += new System.Windows.Forms.MeasureItemEventHandler(this.HelpAbout_MeasureItem);
			// 
			// DisableOpen
			// 
			this.DisableOpen.Location = new System.Drawing.Point(256, 8);
			this.DisableOpen.Name = "DisableOpen";
			this.DisableOpen.Size = new System.Drawing.Size(136, 24);
			this.DisableOpen.TabIndex = 0;
			this.DisableOpen.Text = "&Disable Menu Open";
			this.DisableOpen.CheckedChanged += new System.EventHandler(this.DisableOpen_CheckedChanged);
			// 
			// HideSave
			// 
			this.HideSave.Location = new System.Drawing.Point(256, 40);
			this.HideSave.Name = "HideSave";
			this.HideSave.Size = new System.Drawing.Size(128, 24);
			this.HideSave.TabIndex = 1;
			this.HideSave.Text = "&Hide Menu Save";
			this.HideSave.CheckedChanged += new System.EventHandler(this.HideSave_CheckedChanged);
			// 
			// CustomBackground
			// 
			this.CustomBackground.Location = new System.Drawing.Point(256, 72);
			this.CustomBackground.Name = "CustomBackground";
			this.CustomBackground.Size = new System.Drawing.Size(184, 24);
			this.CustomBackground.TabIndex = 2;
			this.CustomBackground.Text = "Use &custom menu background";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(440, 97);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.CustomBackground,
																		  this.HideSave,
																		  this.DisableOpen});
			this.Menu = this.mainMenu1;
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Advanced Menus";
			this.Resize += new System.EventHandler(this.MainForm_Resize);
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		
		// Our DLL with resources. If this DLL is not in the current
		// directory we'll need to specify full path here:
		const string DefaultResource = "Advanced Menus Res.dll";

		// Initializing a single menu item:
		private void InitMenuItem(VXPLibrary.VXPQuickHTML qhtml, string ItemRes)
		{
			// Setting the default resource file:
			qhtml.SetDefaultRes(DefaultResource);

			// Setting contents of the menu item:
			qhtml.SetSourceText("<txt res='html:idr_" + ItemRes+"'>");

			// We need to draw all menu items using transparency:
			qhtml.Transparent=true;
		}

		private void CheckMenuInit()
		{
			// We didn't simply put all these initializations
			// into MainForm_Load because for menu caption items
			// method OnMeasureItem is called before MainForm_Load,
			// and this is why we also do this verification here:

			if(fNew.Width == 0) // Just one way of verifying whether not initialized yet
			{
				InitMenuItem(fNew, "new");
				InitMenuItem(fOpen, "open");
				InitMenuItem(fSave, "save");
				InitMenuItem(fPreview, "preview");
				InitMenuItem(fPrint, "print");
				InitMenuItem(fExit, "exit");
				InitMenuItem(fAbout, "about");
				InitMenuItem(fFile, "file");
				InitMenuItem(fHelp, "help");
				InitMenuItem(fSeparator, "separator");
				InitMenuItem(fCaption, "caption");
				InitMenuItem(fFooter, "footer");
				InitMenuItem(fMenuBar, "menubar");
			}
		}
		
		// This function is for easier formatting of the tooltip resource string:
		private string FormatTooltip(string strName)
		{
			// We will be using the same QHTML documents for our tooltips
			// just to save time creating new ones. In practise you will create
			// new QHTML documents for tooltips.
			// Here we also override some extra formatting to those QHTML documents
			// used for menus:
			return "<body bgcolor=LightYellow; GFC=LightPink; grad=vert; font=tool;><font color=DarkBlue weight=700>Selected menu item contains:</font><hr size=1 color=Maroon><txt res='html:idr_" + strName + "'>";
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Selecting a tooltip theme:
			tt.tool.Theme = VXPLibrary.VXPTooltipTheme.ttSlick;

			// Show tooltips after just 0.1 second:
			tt.ShowDelay = 100;

			// Setting the default resource file:
			tt.tool.html.SetDefaultRes(DefaultResource);
			
			// Adding the same tooltips as menu items;
			// Note: We found out what Command ID-s are used
			// for menu items by using debug mode of the tooltips
			// set as this: tt.DebugMode = true;
			tt.commands.Add(258, FormatTooltip("new"));
			tt.commands.Add(259, FormatTooltip("open"));
			tt.commands.Add(260, FormatTooltip("save"));
			tt.commands.Add(262, FormatTooltip("preview"));
			tt.commands.Add(263, FormatTooltip("print"));
			tt.commands.Add(265, FormatTooltip("exit"));
			tt.commands.Add(268, FormatTooltip("about"));

			// Attaching tooltips to menu caption and footer:
			tt.commands.Add(257, "<body bgcolor=SkyBlue gfc=White grad=vert>This is a menu caption<hr size=1>Neat, isn't it? :-)");
			tt.commands.Add(266, "<body bgcolor=SkyBlue gfc=White grad=vert>This is a menu footer :-)<hr size=1>Could look much better, b.t.w.");

			// Attaching very simple tooltips to the three
			// check boxes on the form:
			tt.windows.Add(HideSave.Handle.ToInt32(), "Hides menu item <b><u>S</u>ave</b><br>in menu <b><u>F</u>ile Menu</b>");
			tt.windows.Add(DisableOpen.Handle.ToInt32(), "Disables menu item <b><u>O</u>pen</b><br>in menu <b><u>F</u>ile Menu</b>");
			tt.windows.Add(CustomBackground.Handle.ToInt32(), "Overrides background color<br>in all menus of the application.");

			// Initializing all our menu items. Well, since we override
			// drawing for menu caption items as well this means CheckMenuItem()
			// will be called before we get here, which means this method
			// won't do anything on the second call, and can be removed from here.
			// We let it here just for the cause :-)
			CheckMenuInit();
		}

		// This simple method is to brighten up a color in a way
		// that corresponds to XP-Style selection for menu items:
		private Color BrightenColor(Color C)
		{
			const double Factor = 0.75;
			return Color.FromArgb((byte)(Factor * (255 - C.R) + C.R), (byte)(Factor * (255 - C.G) + C.G), (byte)(Factor * (255 - C.B) + C.B), 255);
		}

		// This method draws a single menu item - parameter:
		private void DrawMenuItem(VXPLibrary.VXPQuickHTML qhtml, System.Windows.Forms.DrawItemEventArgs e)
		{
			if((e.State & DrawItemState.Selected) > 0) // If the item is selected
			{
				// Creating a solid brush to draw menu item selection
				SolidBrush bg = new SolidBrush(BrightenColor(System.Drawing.SystemColors.Highlight));

				// Creating a pen to draw rectangle area with a darker selection color
				// to replicate XP-Style selection:
				Pen p = new Pen(System.Drawing.SystemColors.Highlight);

				if((e.State & DrawItemState.Disabled) == 0) // If the item is disabled
					e.Graphics.FillRectangle(bg, e.Bounds.Left, e.Bounds.Top, e.Bounds.Right - e.Bounds.Left, e.Bounds.Bottom - e.Bounds.Top); // Draw disabled item

				// Drawing a dark-color rectangle around selection:
				e.Graphics.DrawRectangle(p, e.Bounds.Left, e.Bounds.Top, e.Bounds.Right - e.Bounds.Left - 1, e.Bounds.Bottom - e.Bounds.Top - 1);
			}
			else // If the item is not selected
				// Just fill the item background with the system menu brush:
				if(CustomBackground.Checked) // If we want to override menu background
				{
					SolidBrush menubg = new SolidBrush(Color.FromArgb(255, 255, 220));
					e.Graphics.FillRectangle(menubg, e.Bounds.Left, e.Bounds.Top, e.Bounds.Right - e.Bounds.Left, e.Bounds.Bottom - e.Bounds.Top);
				}
				else
					e.Graphics.FillRectangle(System.Drawing.SystemBrushes.Menu, e.Bounds.Left, e.Bounds.Top, e.Bounds.Right - e.Bounds.Left, e.Bounds.Bottom - e.Bounds.Top);

			// Allocating the current Device Context:
			System.IntPtr dc = e.Graphics.GetHdc();

			if((e.State & DrawItemState.Disabled) > 0) // If the item is disabled
				qhtml.DrawState(dc.ToInt32(), (short)e.Bounds.Left, (short)e.Bounds.Top, (int)VXPLibrary.VXPDrawState.dssDisabled, (uint)0);
			else
				qhtml.Draw(dc.ToInt32(), (short)e.Bounds.Left, (short)e.Bounds.Top);
			
			// Releasing the Device Context:
			e.Graphics.ReleaseHdc(dc);
		}

		// For menu captions drawing procedure is a little different from that
		// for regular menu items in a way that we have to use extra offsets
		// for better visual effect, plus caption item can be highlighted but
		// not selected, and we also draw a custom menu bar:
		private void DrawMenuCaptionItem(VXPLibrary.VXPQuickHTML qhtml, System.Windows.Forms.DrawItemEventArgs e)
		{
			if((e.State & DrawItemState.Selected) > 0 || (e.State & DrawItemState.HotLight) > 0)
			{ // If the item is selected or highlighted:

				// Creating a solid brush to draw menu item selection
				SolidBrush bg = new SolidBrush(BrightenColor(System.Drawing.SystemColors.Highlight));

				// Creating a pen to draw rectangle area with a darker selection color:
				// to replicate XP-Style selection:
				Pen p = new Pen(System.Drawing.SystemColors.Highlight);

				if((e.State & DrawItemState.Disabled) == 0) // If the item is disabled
					e.Graphics.FillRectangle(bg, e.Bounds.Left, e.Bounds.Top, e.Bounds.Right - e.Bounds.Left, e.Bounds.Bottom - e.Bounds.Top);
				e.Graphics.DrawRectangle(p, e.Bounds.Left, e.Bounds.Top, e.Bounds.Right - e.Bounds.Left - 1, e.Bounds.Bottom - e.Bounds.Top - 1);
			}
			else // If the item is not selected
				// Just fill the item background with the system menu brush:
				e.Graphics.FillRectangle(System.Drawing.SystemBrushes.Control, e.Bounds.Left, e.Bounds.Top, e.Bounds.Right - e.Bounds.Left, e.Bounds.Bottom - e.Bounds.Top);

			// Allocating the current Device Context:
			System.IntPtr dc = e.Graphics.GetHdc();

			if(qhtml == fHelp) // If we are drawing item help we can stretch it over the whole menu bar!!!
			{
				// First drawing a horizontal gradient.
				// The gradient starts with the MenuBar color, and ends with Silver color.
				fNew.GradientFillRect(dc.ToInt32(), RGB(System.Drawing.SystemColors.Control.R,System.Drawing.SystemColors.Control.G, System.Drawing.SystemColors.Control.B), RGB(110, 110, 110), (short)e.Bounds.Right, (short)e.Bounds.Top, (short)(this.Width - 4), (short)e.Bounds.Bottom, true);

				if (this.Width - fMenuBar.Width > e.Bounds.Right) // If our fMenuBar document will fit in the empty menu bar area
					// Now drawing our QHTML document aligned to the right part of the menu bar:
					fMenuBar.Draw(dc.ToInt32(), (short)(this.Width - fMenuBar.Width - 6), (short)(e.Bounds.Top + 2));
			}

			if((e.State & DrawItemState.Disabled) > 0) // If the item is disabled
				// Drawing the menu item with necessary constant offset {5, 2}:
				qhtml.DrawState(dc.ToInt32(), (short)(e.Bounds.Left + 5), (short)(e.Bounds.Top + 2), (int)VXPLibrary.VXPDrawState.dssDisabled, (uint)0);
			else
				// Drawing the menu item with necessary constant offset {5, 2}:
				qhtml.Draw(dc.ToInt32(), (short)(e.Bounds.Left + 5), (short)(e.Bounds.Top + 2));

			// Releasing the Device Context:	
			e.Graphics.ReleaseHdc(dc);
		}

		// For separators the drawing procedure is much simplier:
		private void DrawSeparator(VXPLibrary.VXPQuickHTML qhtml, System.Windows.Forms.DrawItemEventArgs e)
		{
			// Allocating the current Device Context:
			System.IntPtr dc = e.Graphics.GetHdc();

			// Drawing our separator - parameter:
			qhtml.Draw(dc.ToInt32(), (short)e.Bounds.Left, (short)e.Bounds.Top);

			// Releasing the Device Context:
			e.Graphics.ReleaseHdc(dc);
		}

		// This simple procedure is just to set dimension
		// of a single menu item:
		private void MeasureMenuItem(VXPLibrary.VXPQuickHTML qhtml, System.Windows.Forms.MeasureItemEventArgs e)
		{
			e.ItemWidth = qhtml.Width;
			e.ItemHeight = qhtml.Height;
		}

		// This procedure sets dimensions for a caption menu item:
		private void MeasureMenuCaptionItem(VXPLibrary.VXPQuickHTML qhtml, System.Windows.Forms.MeasureItemEventArgs e)
		{
			CheckMenuInit();	// Necessary to call, because this method can be called
								// even before MainForm_Load
			
			e.ItemWidth = qhtml.Width;
			
			e.ItemHeight = 0;	// Height for caption menu items is ignored by Windows itself
		}

		// Changing menu item "Open" according to the check flag:
		private void DisableOpen_CheckedChanged(object sender, System.EventArgs e)
		{
			FileOpen.Enabled = !DisableOpen.Checked;
		}

		// Changing visibility of menu item "Save":
		private void HideSave_CheckedChanged(object sender, System.EventArgs e)
		{
			FileSave.Visible = !HideSave.Checked;
		}

		// When selected "Exit" from menu:
		private void FileExit_Click(object sender, System.EventArgs e)
		{
			this.Close(); // Closing the form:
		}

		// Exporting a function needed within MainForm_Resize
		// to update menu bar of the form when it is resized:
		[DllImport("User32.dll")]
		public static extern int DrawMenuBar(long hWindow);

		// When the form is resized we need to update our menu bar,
		// because we draw some graphics on it that needs to be aligned
		// by the right border of the window.
		private void MainForm_Resize(object sender, System.EventArgs e)
		{
			// Updating the menu bar:
			DrawMenuBar(this.Handle.ToInt32());
		}

	/**************************************************************/
	// Handlers for measuring and drawing all our menu items:
	/**************************************************************/

		private void FileNew_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			DrawMenuItem(fNew, e);
		}

		private void FileNew_MeasureItem(object sender, System.Windows.Forms.MeasureItemEventArgs e)
		{
			MeasureMenuItem(fNew, e);
		}

		private void FileOpen_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			DrawMenuItem(fOpen, e);
		}

		private void FileOpen_MeasureItem(object sender, System.Windows.Forms.MeasureItemEventArgs e)
		{
			MeasureMenuItem(fOpen, e);
		}

		private void FileSave_MeasureItem(object sender, System.Windows.Forms.MeasureItemEventArgs e)
		{
			MeasureMenuItem(fSave, e);
		}

		private void FileSave_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			DrawMenuItem(fSave, e);
		}

		private void FilePreview_MeasureItem(object sender, System.Windows.Forms.MeasureItemEventArgs e)
		{
			MeasureMenuItem(fPreview, e);
		}

		private void FilePreview_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			DrawMenuItem(fPreview, e);
		}

		private void FilePrint_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			DrawMenuItem(fPrint, e);
		}

		private void FilePrint_MeasureItem(object sender, System.Windows.Forms.MeasureItemEventArgs e)
		{
			MeasureMenuItem(fPrint, e);
		}

		private void FileExit_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			DrawMenuItem(fExit, e);
		}

		private void FileExit_MeasureItem(object sender, System.Windows.Forms.MeasureItemEventArgs e)
		{
			MeasureMenuItem(fExit, e);
		}

		private void HelpAbout_MeasureItem(object sender, System.Windows.Forms.MeasureItemEventArgs e)
		{
			MeasureMenuItem(fAbout, e);
		}

		private void HelpAbout_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			DrawMenuItem(fAbout, e);
		}

		private void FileMenu_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			DrawMenuCaptionItem(fFile, e);
		}

		private void FileMenu_MeasureItem(object sender, System.Windows.Forms.MeasureItemEventArgs e)
		{
			MeasureMenuCaptionItem(fFile, e);
		}

		private void HelpMenu_MeasureItem(object sender, System.Windows.Forms.MeasureItemEventArgs e)
		{
			MeasureMenuCaptionItem(fHelp, e);
		}

		private void HelpMenu_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			DrawMenuCaptionItem(fHelp, e);
		}

		private void Separator1_MeasureItem(object sender, System.Windows.Forms.MeasureItemEventArgs e)
		{
			e.ItemHeight=fSeparator.Height;
		}

		private void Separator1_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			DrawSeparator(fSeparator, e);
		}

		private void Separator2_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			DrawSeparator(fSeparator, e);
		}

		private void Separator2_MeasureItem(object sender, System.Windows.Forms.MeasureItemEventArgs e)
		{
			e.ItemHeight=fSeparator.Height;
		}

		private void FileCaption_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			DrawSeparator(fCaption, e);
		}

		private void FileCaption_MeasureItem(object sender, System.Windows.Forms.MeasureItemEventArgs e)
		{
			// For the caption we have to ignore Width
			e.ItemHeight=fCaption.Height;
		}

		private void FileFooter_DrawItem(object sender, System.Windows.Forms.DrawItemEventArgs e)
		{
			DrawSeparator(fFooter, e);
		}

		private void FileFooter_MeasureItem(object sender, System.Windows.Forms.MeasureItemEventArgs e)
		{
			// For the footer we have to ignore Width
			e.ItemHeight=fFooter.Height;
		}
	}
}
