using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

///////////////////////////////////////////////////////////////////////////////////
// VXPLib example
//
// SliderTooltips for C#
//
// Last Modified on 13/06/2003
//
// This example is intellectual property of Tooltips.NET L.L.C.
//
// For details visit www.Tooltips.NET
///////////////////////////////////////////////////////////////////////////////////

namespace SliderTooltip
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TrackBar Slider;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;

		// Instance of VXPLib Tooltip Manager:
		private VXPLibrary.VXPTooltipManager ttm = new VXPLibrary.VXPTooltipManagerClass();
		private System.Windows.Forms.TrackBar Slider2;

		// Instance of VXPLib Tooltip:
		private VXPLibrary.VXPTooltip tt = new VXPLibrary.VXPTooltipClass();

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Slider = new System.Windows.Forms.TrackBar();
			this.Slider2 = new System.Windows.Forms.TrackBar();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.Slider)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.Slider2)).BeginInit();
			this.SuspendLayout();
			// 
			// Slider
			// 
			this.Slider.BackColor = System.Drawing.Color.LightSteelBlue;
			this.Slider.Location = new System.Drawing.Point(8, 104);
			this.Slider.Maximum = 40;
			this.Slider.Name = "Slider";
			this.Slider.Size = new System.Drawing.Size(336, 42);
			this.Slider.TabIndex = 0;
			// 
			// Slider2
			// 
			this.Slider2.Location = new System.Drawing.Point(8, 32);
			this.Slider2.Maximum = 40;
			this.Slider2.Name = "Slider2";
			this.Slider2.Size = new System.Drawing.Size(336, 42);
			this.Slider2.TabIndex = 1;
			this.Slider2.MouseEnter += new System.EventHandler(this.Slider2_MouseEnter);
			this.Slider2.MouseLeave += new System.EventHandler(this.Slider2_MouseLeave);
			this.Slider2.Scroll += new System.EventHandler(this.Slider2_Scroll);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 80);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(304, 23);
			this.label1.TabIndex = 2;
			this.label1.Text = "When progress for the slider can be shown with a delay:";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(296, 23);
			this.label2.TabIndex = 3;
			this.label2.Text = "When showing the slider progress must be instantaneous:";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.LightSteelBlue;
			this.ClientSize = new System.Drawing.Size(352, 157);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label2,
																		  this.label1,
																		  this.Slider2,
																		  this.Slider});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Slider Tooltip";
			this.Load += new System.EventHandler(this.MainForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.Slider)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.Slider2)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Attaching event handler:
			this.ttm.OnActivateCustomTooltip += new VXPLibrary._IVXPTooltipManagerEvents_OnActivateCustomTooltipEventHandler(this.ttm_OnActivateCustomTooltip);

			// The following set of parameters seems to be
			// optimum for sliders that allow delays:
			ttm.ShowDelay = 150;
			ttm.tool.FadeHide=150;
			ttm.tool.FadeShow=150;

			// Setting up some parameters for our simple
			// tooltip object:
			tt.Autohide = false; // Do not hide automatically
			tt.TraceMode=true;	// Follow the mouse cursor
			// No fading effect:
			tt.FadeHide=0;
			tt.FadeShow=0;			
		}
		
		// This event is called for any window that doesn't have
		// a tooltip attached to it:
		private void ttm_OnActivateCustomTooltip(int hWnd, string ClassName, short X, short Y, ref string Text)
		{
			if(hWnd == Slider.Handle.ToInt32()) // If this is our sliding control
				Text = "<body bgcolor=LightSkyBlue gfc=white grad=vert text=black>Current scroll<br>value: <font color=blue weight=700>"+Slider.Value.ToString();
		}

		private void ShowSimpleTooltip()
		{
			// Update the current QHTML document in the tooltip:
			tt.html.SetSourceText("<body bgcolor=LightPink gfc=LightYellow text=black>Current scroll value: <font color=blue weight=700>"+Slider2.Value.ToString());

			// Because we do not even hide the tooltip we have
			// to call recalculation of layout manually:
			tt.html.RecalculateLayout();

			// Show the tooltip at the current mouse position:
			tt.Show();
		}

		private void Slider2_Scroll(object sender, System.EventArgs e)
		{
			// Show the tooltip:
			ShowSimpleTooltip();
		}

		private void Slider2_MouseEnter(object sender, System.EventArgs e)
		{
			// Show the tooltip:
			ShowSimpleTooltip();
		}

		private void Slider2_MouseLeave(object sender, System.EventArgs e)
		{
			// Hiding the simple tooltip object:
			tt.Hide(false);
		}
	}
}
